
class com.amduus.misc.Strings:

  define public variable CRLF as character no-undo.
  
  constructor public Strings():
  
    CRLF = chr(13) + chr(10).
    
  end. /* constructor */
  
  /**************************************************************************/
  /* One should use -rand 2 on the client start up for this routine.        */
  /**************************************************************************/
  
  method public character RandomString (input SizeOf as integer):
  
    return RandomStringByAlphabet(SizeOf, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789").
    
  end. /* RandomString */
  
  /**************************************************************************/
  /* One can specify the alphabet of characters to use with this one.       */
  /**************************************************************************/
  
  method public character RandomStringByAlphabet(input SizeOf as integer, input Alphabet as character):
  
    define variable ETimeAsString as character no-undo.
    define variable ReturnString as character init "" no-undo.
    define variable CurrentIter as integer no-undo.
    
    /* We use etime to try and enforce randomness even if the -rand 2 option */
    /* is not used.                                                          */
    
    ETimeAsString = string(etime).
    
    do CurrentIter = 1 to SizeOf - length(ETimeAsString):
      
      ReturnString = ReturnString
                   + substring (Alphabet, Random(1, length(Alphabet)), 1).
                   
    end. /* do CurrentIter = 1 to SizeOf */
    
    return ReturnString + ETimeAsString.
    
  end. /* RandomStringByAlphabet */
  
  /**************************************************************************/
  /* There are times we want to send a longchar out with a statement that   */
  /* can only deal with character (put for example.)  So we have a chunker  */
  /* that a programmer can use to divy up a long into chunks of character.  */
  /**************************************************************************/
  
  /* Set your chunk size here.  Defaults to 12000. */
  
  define public variable ChunkSize as integer init 12000 no-undo.
  define public variable ChunkIter as integer no-undo.
  define private variable ChunkerData as longchar no-undo.
  define private variable ChunkerDataSize as integer no-undo.
  
  method public void NewChunk(input Data as longchar):
  
    ChunkerData = Data.
    ChunkerDataSize = length(ChunkerData).
    ChunkIter = 1.
    
  end. /* NewChunk */
  
  method public integer NumberOfChunks():
  
    return max (1, int(ChunkerDataSize / ChunkSize)).
    
  end. /* NumberOfChunks */
  
  method public character GetChunk():
  
   define variable T as character no-undo.
   
   T = substring (ChunkerData, ChunkIter, ChunkSize).
   
   ChunkIter = ChunkIter + ChunkSize.
   
   return T.
  
  end. /* GetChunk */
  
  method public logical EndOfChunkData():
  
    if ChunkIter - 1 >= ChunkerDataSize then return true.
      
    return false.
    
  end. /* EndOfChunkData */
  
  
  
end. /* class */

/**************************************************************************
                           UNIT TEST CODE

define variable S as com.amduus.misc.Strings no-undo.

S = new com.amduus.misc.Strings().

display S:RandomString(20) format "X(30)".

/* for 10.1a */
def var t as longchar.
t = "01234567890123456789".

S:NewChunk(t).
S:ChunkSize = 5.
do while not S:EndOfChunkData():
  message S:GetChunk().
end.


delete object S.

**************************************************************************/

