/**************************************************************************/
/*                              PLEASE READ                               */
/*                                ______                                  */
/*                             .-"      "-.                               */
/*                            /            \                              */
/*                _          |              |          _                  */
/*               ( \         |,  .-.  .-.  ,|         / )                 */
/*                > "=._     | )(__/  \__)( |     _.=" <                  */
/*               (_/"=._"=._ |/     /\     \| _.="_.="\_)                 */
/*                      "=._ (_     ^^     _)"_.="                        */
/*                          "=\__|IIIIII|__/="                            */
/*                         _.="| \IIIIII/ |"=._                           */
/*               _     _.="_.="\          /"=._"=._     _                 */
/*              ( \_.="_.="     `--------`     "=._"=._/ )                */                                          
/*               > _.="  DO NOT EDIT FRIVOLOUSLY!  "=._ <                 */
/*              (_/                                    \_)                */
/**************************************************************************/
/* This class is to prevent a type of hacking called Command Line         */
/* Injection.  Be sure you understand what this means before fooling      */
/* around in here.                                                        */
/**************************************************************************/


class com.amduus.security.CLI:

  /**************************************************************************/
  /* When offering up data to the command line, one may want to be sure to  */
  /* escape it with this method.                                            */
  /**************************************************************************/
  
  method public character EscapeCLI(input T as character):
  
    T = replace (T, ";", "~\;").
    T = replace (T, "$", "~\$").
    T = replace (T, "~"", "~\~"").
    
    return T.
    
  end. /* EscapeCLI */
  
end. /* class */

/**************************************************************************
                                UNIT TEST CODE
                                
define variable CLI as com.amduus.security.CLI no-undo.

CLI = new com.amduus.security.CLI().

display CLI:EscapeCLI("$(echo this)") format "x(20)".

delete object CLI.
                                
**************************************************************************/
